routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('layout');
//});
//Route::resource('agences', 'AgenceController');
//Route::resource('regionals', 'RegionalController');
//Route::resource('centrals', 'CentralController');
//Route::resource('structures/{type_id}', 'StructureController');
Auth::routes();
Route::get('/', 'HomeController@index')->name('home');
Route::middleware(['web'])->group(function () {



    Route::get('historiques', 'HistoryController@index');
    Route::resource('user', 'UserController');
    Route::put('user/{id}/edit', 'UserController@password')->name('user.password');
    Route::resource('document', 'DocumentController');
    Route::resource('nomenclature', 'NomenclatureController');
    Route::resource('calendrier', 'CalendrierController');
    Route::get('versement', 'VersementController@index')->name('versement.index');
    Route::post('versement', 'VersementController@decision')->name('versement.decision');
    Route::get('demande', 'DemandeController@index')->name('demande.index');
    Route::post('demande/{id}', 'DemandeController@decision')->name('demande.decision');

    Route::get('/ajax/structurestype/{type?}', 'UserController@StructuresType')->name('ajax.structurestype');
    Route::get('structures/{type_id}', 'StructureController@index')->name('structure.index');
    Route::get('structures/{type_id}/create', 'StructureController@create')->name('structure.create');
    Route::post('structures/{type_id}', 'StructureController@store')->name('structure.store');
    Route::get('structures/{type_id}/{structure}/edit', 'StructureController@edit')->name('structure.edit');
    Route::put('structures/{type_id}/{structure}', 'StructureController@update')->name('structure.update');
    Route::get('structures/{type_id}/{structure}', 'StructureController@show')->name('structure.show');
    Route::delete('structures/{type_id}/{structure}', 'StructureController@destroy')->name('structure.delete');

    Route::get('consultation', 'ConsultationController@index')->name('consultation.index');
    Route::post('consultation/create', 'ConsultationController@store')->name('consultation.store');
    Route::get('consultation/create', 'ConsultationController@create')->name('consultation.create');
    Route::post('consultation/{id}', 'ConsultationController@decision')->name('consultation.decision');


    Route::get('enlevement/demandes', 'EnlevementController@demandes')->name('enlevement.demandes');
    Route::put('enlevement/demandes/{enlevement}', 'EnlevementController@date')->name('enlevement.date');
    Route::get('enlevement/calendar', 'EnlevementController@calendar')->name('enlevement.calendar');
    Route::resource('enlevement', 'EnlevementController');


});

app/Document.php
<?php

namespace App;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;

class Document extends Model
{
    protected $dates = [
        'created_at',
        'updated_at',
        'age1',
        'age2',
        'age3',
        // your other new column
    ];
    protected $guarded=[];
    public function nomenclature()
    {
        return $this->belongsTo('App\Nomenclature');
    }
    public function user()
    {
        return $this->belongsTo('App\User');
    }
    public function versement()
    {
        return $this->belongsTo('App\Versement');
    }
    public function time($id)
    {
        $document=Document::find($id)->first();
        $dt=Carbon::now();
        if($dt->greaterThanOrEqualTo($document->created_at->addMinute()))
            return 0;
        return 1;
    }
}

app/Http/Controllers/DocumentController.php
<?php

namespace App\Http\Controllers;

use App\Document;
use App\Enlevement;
use App\History;
use App\Nomenclature;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class DocumentController extends Controller
{

    public function index()
    {
        $date =today()->format('Y-m-d');
        $user=Auth::user();
        if( ($user->structure->type->id== 1) || ($user->structure->type->id== 2) || ($user->structure->type->id == 3) )
        {
            Document::where('age1', '<', $date)->update(['traitement' =>'1']);
            $documents = Document::where('statut', '1')->where('user_id',$user->id);
        }

        elseif($user->structure->type->id== 4)
        {
            $date=today()->format('Y-m-d');
//            $enlevement=Document::join('enlevements','documents.structure_id','enlevements.structure_id')
//                ->where('enlevements.date','<',$date)
//                ->where('documents.enlevement','=',1)
//                ->where('documents.traitement','!=',1)
//                ->where('enlevements.statut','1');
//            $enlevement->update(['documents.statut'=>'2','documents.enlevement'=>0,'traitement'=>'0']);

            Document::where('age2', '<', $date)->update(['traitement' =>'1']);
            $documents = Document::where('statut','=', '2')->where('enlevement',0);
        }

        else
        {
//            $enlevement=Document::join('enlevements','documents.enlevement_id','enlevements.id')
//                ->where('enlevements.date','<=',$date)
//                ->where('documents.enlevement',1)
//                ->where('enlevements.statut',2);
////            dd($enlevement->get());
//            $enlevement->update(['documents.statut'=>'3','documents.enlevement'=>0,'traitement'=>'0']);
            Document::where('age3', '<', $date)->where('traitement',0)->update(['traitement' =>'1']);
            $documents = Document::where('statut','3')->where('enlevement',0);
        }

        $documents = $documents->whereIn('traitement',['0','2'])->get();
//        dd($documents);

        return view('documents.index',compact('documents'));
    }


    public function create()
    {
        $nomenclatures=Nomenclature::all();
        return view('documents.create',compact('nomenclatures'));
    }


    public function store(Request $request)
    {
        $request->validate([
            'num' => 'required|unique:documents',
            'pages' => 'required',
            'nbrdoc' => 'required',
            'chapitre' => 'required',
//            'nomenclature_id' => 'required',
//            'type_id' => 'required',
//            'structure_id' => 'required',
        ]);
        $document=new Document();
        $document->num=$request->num;
        $document->pages=$request->pages;
        $document->nbrdoc=$request->nbrdoc;
        $document->chapitre=$request->chapitre;
        $document->nomenclature_id=$request->nomenclature;
        $document->user_id=Auth::user()->id;
        $document->structure_id=Auth::user()->structure_id;
        $dt=Carbon::now();
        $nomenclature=Nomenclature::find($request->nomenclature);
        $age1=json_decode($nomenclature->age1);
        $age2=json_decode($nomenclature->age2);
        $age3=json_decode($nomenclature->age3);

        $document->age1=$dt->addYears($age1->year);
        $document->age1=$dt->addMonths($age1->month);
        $document->age1=$dt->addDays($age1->day);
        $dt1=$document->age1;
        $document->save();
        $document->age2=$dt1->addYears(($age2->year));
        $document->age2=$dt1->addMonths($age2->month);
        $document->age2=$dt1->addDays(($age2->day));
        $dt2=$document->age2;
        $document->save();
        $document->age3=$dt2->addYears($age3->year);
        $document->age3=$dt2->addMonths($age3->month);
        $document->age3=$dt2->addDays($age3->day);

        $document->save();
        History::create([
            'structure_id'=>Auth::user()->structure->id,
            'user_id'=>Auth::id(),
            'action'=>'Création d\'un document'
        ]);
//        dd($document);
        return redirect(route('document.index'))->with('message','Document '.$document->num.' a été crée avec succès ');
    }


    public function show(Document $document)
    {
        return view('documents.show',compact('document'));
    }

    public function edit(Document $document)
    {
        $nomenclatures=Nomenclature::all();
        return view('documents.edit',compact('document','nomenclatures'));
    }


    public function update(Request $request, Document $document)
    {
        $request->validate([
            'num' => 'required|unique:documents',
            'pages' => 'required',
            'nbrdoc' => 'required',
            'chapitre' => 'required',
//            'nomenclature_id' => 'required',
//            'type_id' => 'required',
//            'structure_id' => 'required',
        ]);
        $document->num=$request->num;
        $document->pages=$request->pages;
        $document->nbrdoc=$request->nbrdoc;
        $document->chapitre=$request->chapitre;
        $document->nomenclature_id=$request->nomenclature;
        $document->user_id=Auth::user()->id;
        $document->structure_id=Auth::user()->structure_id;
        $dt=Carbon::now();
        $nomenclature=Nomenclature::find($request->nomenclature);
        $age1=json_decode($nomenclature->age1);
        $age2=json_decode($nomenclature->age2);
        $age3=json_decode($nomenclature->age3);

        $document->age1=$dt->addYears($age1->year);
        $document->age1=$dt->addMonths($age1->month);
        $document->age1=$dt->addDays($age1->day);
//        $dt=$document->age1;
        $document->age2=$dt->addYears(int($age2->year+$age1->year));
        dd();
        $document->age2=$dt->addMonths($age2->month+$age1->month);
        $document->age2=$dt->addDays($age2->day+$age1->day);
//        $dt=$document->age2;
        $document->age3=$dt->addYears($age3->year+$age2->year);
        $document->age3=$dt->addMonths($age3->month+$age2->year);
        $document->age3=$dt->addDays($age3->day+$age2->year);
        $document->update();
        History::create([
            'structure_id'=>Auth::user()->structure->id,
            'user_id'=>Auth::id(),
            'action'=>'Modification d\'un document'
        ]);
        return redirect(route('document.index'))->with('message','Document '.$document->num.' a été modifiée avec succès ');;
    }


    public function destroy(Document $document)
    {
        $num=$document->num;
        $document->delete();
        History::create([
            'structure_id'=>Auth::user()->structure->id,
            'user_id'=>Auth::id(),
            'action'=>'Suppression d\'un document'
        ]);
        return redirect(route('document.index'))->with('message','Document '.$num.' a été supprimée avec succès ');
    }
}

resources/views/documents/create.blade.php
@extends('layout')
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont
                    icofont-file-alt
                        bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Document</h4>
                        <span>Créer Un<code style="text-transform: uppercase">Document</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Créer Un Document</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- Basic Form Inputs card start -->
                <div class="card">

                    <div class="card-block">
                        <h4 class="sub-title">Formulaire de création</h4>
                        <form method="post" action="{{route('document.store')}}">
                            @csrf
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Numéro document</label>
                                <div class="col-sm-10">
                                    <input name="num" type="number" class="form-control">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nombre pages</label>
                                <div class="col-sm-10">
                                    <input name="pages" type="number" class="form-control" placeholder="Nombre pages">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nombre documents</label>
                                <div class="col-sm-10">
                                    <input name="nbrdoc" type="number" class="form-control" placeholder="Nombre documents">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Chapitre Comptable</label>
                                <div class="col-sm-10">
                                    <input name="chapitre" type="text" class="form-control" placeholder="Chapitre Comptable">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nomenclature</label>
                                <div class="col-sm-10">
                                    <select required name="nomenclature" class="form-control">
                                        <option disabled selected >Choisir la nomenclature</option>
                                        @foreach($nomenclatures as $nomenclature)
                                            <option value="{{$nomenclature->id}}">{{$nomenclature->designation}}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <div class="text-center">
                            <button type="submit" class="col-md-3 btn btn-out-dashed btn-success btn-square">Créer</button>
                            </div>
                        </form>
                    </div>
                </div>
                <!-- Basic Form Inputs card end -->
            </div>
        </div>

    </div>
@endsection

resources/views/documents/edit.blade.php
@extends('layout')
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont
                    icofont-file-alt
                        bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Document</h4>
                        <span>Modifier Un<code style="text-transform: uppercase">Document</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Modifier Un Document</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- Basic Form Inputs card start -->
                <div class="card">

                    <div class="card-block">
                        <h4 class="sub-title">Formulaire de Modification</h4>
                        <form method="post" action="{{route('document.update',$document->id)}}">
                            @csrf
                            @method('put')
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Numéro document</label>
                                <div class="col-sm-10">
                                    <input value="{{$document->num}}" name="num" type="text" class="form-control">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nombre pages</label>
                                <div class="col-sm-10">
                                    <input value="{{$document->pages}}"  name="pages" type="text" class="form-control" placeholder="Nombre pages">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nombre documents</label>
                                <div class="col-sm-10">
                                    <input value="{{$document->nbrdoc}}" name="nbrdoc" type="text" class="form-control" placeholder="Nombre documents">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Chapitre Comptable</label>
                                <div class="col-sm-10">
                                    <input value="{{$document->chapitre}}" name="chapitre" type="text" class="form-control" placeholder="Chapitre Comptable">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nomenclature</label>
                                <div class="col-sm-10">
                                    <select required name="nomenclature" class="form-control">
                                        <option disabled selected >Choisir la nomenclature</option>
                                        @foreach($nomenclatures as $nomenclature)
                                            <option {{$document->nomenclature->id==$nomenclature->id ? 'selected' : ''}} value="{{$nomenclature->id}}">{{$nomenclature->designation}}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <div class="text-center">
                                <button type="submit" class="col-md-3 btn btn-out-dashed btn-success btn-square">Modifier</button>
                            </div>
                        </form>
                    </div>
                </div>
                <!-- Basic Form Inputs card end -->
            </div>
        </div>

    </div>
@endsection

resources/views/documents/index.blade.php
@extends('layout')
@section('nom')

@endsection
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont
                    icofont-file-alt
                        bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Document</h4>
                        <span>Liste Des <code style="text-transform: uppercase">Documents</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Liste des Documents</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- DOM/Jquery table start -->
                <div class="card">

                    <div class="card-block">
                        @if((Auth::user()->structure->type->id=='1')||(Auth::user()->structure->type->id=='2')||(Auth::user()->structure->type->id=='3'))
                        <a href="{{route('document.create')}}" type="button" id="addRow" class="btn btn-primary m-b-20 float-lg-right">+ Créer Un Nouveau Document
                        </a>
                        @endif
                        <div class="table-responsive dt-responsive">
                            <table id="dom-jqry" class="table table-striped table-bordered nowrap">
                                <thead>
                                <tr>
                                    <th>Numéro</th>
                                    <th>Nombre Pages</th>
                                    <th>Nombre Documents</th>
                                    <th>Chapitre Comptable</th>
                                    @if((Auth::user()->structure->type->id=='1')||(Auth::user()->structure->type->id=='2')||(Auth::user()->structure->type->id=='3'))
                                    <th>Limite Conservation Age 1 </th>
                                    @elseif(Auth::user()->structure->type->id=='4')
                                    <th>Lieu Conservation Age 2</th>
                                    @elseif(Auth::user()->structure->type->id=='5')
                                    <th>Lieu Conservation Age 3</th>
                                    @endif
                                    <th>Nomenclature</th>
                                    <th>Actions</th>
                                </tr>
                                </thead>
                                <tbody>
                                @foreach($documents as $document)
                                    <tr>
                                        <td>{{$document->num}}</td>
                                        <td>{{$document->pages}}</td>
                                        <td>{{$document->nbrdoc}}</td>
                                        <td>{{$document->chapitre}}</td>
                                        @if((Auth::user()->structure->type->id=='1')||(Auth::user()->structure->type->id=='2')||(Auth::user()->structure->type->id=='3'))
                                            <td data-toggle="tooltip" data-placement="left" data-original-title="{{$document->age1->format('d-m-y')}}">{{$document->age1->diffForHumans()}} </td>
                                        @elseif(Auth::user()->structure->type->id=='4')
                                            <td data-toggle="tooltip" data-placement="left" data-original-title="{{$document->age2->format('d-m-y')}}">{{$document->age2->diffForHumans()}} </td>
                                        @elseif(Auth::user()->structure->type->id=='5')
                                            <td data-toggle="tooltip" data-placement="left" data-original-title="{{$document->age3->format('d-m-y')}}">{{$document->age3->diffForHumans()}} </td>
                                        @endif
                                        <td>{{$document->nomenclature->designation}}</td>
                                        <td>
                                            <a href="{{route('document.show',$document->id)}}" class="badge badge-md bg-success"><i class="fa fa-eye"></i></a>
{{--                                            <a href="{{route('document.edit',$document->id)}}" class="badge badge-md bg-info"><i class="fa fa-pencil"></i></a>--}}
{{--                                            @if($document->time($document->id)==1)--}}
{{--                                                <a href="#" data-toggle="modal" data-target="#delete{{$document->id}}" class="badge badge-md bg-danger"><i class="fa fa-trash"></i></a>--}}
{{--                                            @endif--}}
                                        </td>
                                    </tr>
                                    <div class="modal fade" id="delete{{$document->id}}" tabindex="-1" role="dialog">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h4 class="modal-title">Confirmation de Suppression</h4>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                </div>
                                                <div class="modal-body">
                                                    <h5>Etes vous sûr de vouloir Supprimer ce Document "{{$document->num}}"?</h5>
                                                </div>
                                                <div class="modal-footer">
                                                    <form id="form"  method="post" action="{{route('document.destroy',$document->id)}}">
                                                        @csrf
                                                        @method('delete')
                                                        <button type="button" class="btn btn-info waves-effect " data-dismiss="modal">Non</button>
                                                        <button type="submit" class="btn btn-danger waves-effect waves-light ">Oui</button>

                                                    </form>

                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                @endforeach
                                </tbody>
                                <tfoot>
                                <tr>
                                    <th>Numéro</th>
                                    <th>Nombre Pages</th>
                                    <th>Nombre Documents</th>
                                    <th>Chapitre Comptable</th>
                                    @if((Auth::user()->structure->type->id=='1')||(Auth::user()->structure->type->id=='2')||(Auth::user()->structure->type->id=='3'))
                                        <th>Limite Conservation Age 1 </th>
                                    @elseif(Auth::user()->structure->type->id=='4')
                                        <th>Lieu Conservation Age 2</th>
                                    @elseif(Auth::user()->structure->type->id=='5')
                                        <th>Lieu Conservation Age 3</th>
                                    @endif
                                    <th>Nomenclature</th>
                                    <th>Actions</th>
                                </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
                <!-- DOM/Jquery table end -->
            </div>
        </div>
    </div>
@endsection